diff -ruN vdr-1.5.12/PLUGINS/src/pictures/player.c vdr-1.5.13/PLUGINS/src/pictures/player.c
--- vdr-1.5.12/PLUGINS/src/pictures/player.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/player.c	2008-01-13 12:29:27.000000000 +0100
@@ -0,0 +1,249 @@
+/*
+ * player.c: A player for still pictures
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: player.c 1.1 2008/01/13 11:29:27 kls Exp $
+ */
+
+#include "player.h"
+#include <vdr/remote.h>
+#include <vdr/tools.h>
+
+int SlideShowDelay = 3; // seconds
+
+cString HandleUnderscores(const char *s)
+{
+  // Skip anything before and including the first '_' and replace
+  // any remaining '_' with blanks:
+  const char *p = strchr(s, '_');
+  if (p) {
+     p++;
+     char buf[strlen(p) + 1];
+     strcpy(buf, p);
+     return strreplace(buf, '_', ' ');
+     }
+  return s;
+}
+
+// --- cPicturePlayer --------------------------------------------------------
+
+class cPicturePlayer : public cPlayer {
+private:
+  int size;
+  int length;
+  uchar *buffer;
+  virtual void Activate(bool On);
+public:
+  cPicturePlayer(void);
+  ~cPicturePlayer();
+  void SetPicture(const char *FileName);
+  };
+
+cPicturePlayer::cPicturePlayer(void)
+{
+  size = KILOBYTE(100); // will be adjusted automatically if files are larger
+  length = 0;
+  buffer = MALLOC(uchar, size);
+}
+
+cPicturePlayer::~cPicturePlayer()
+{
+  free(buffer);
+}
+
+void cPicturePlayer::Activate(bool On)
+{
+  if (length > 0)
+     DeviceStillPicture(buffer, length);
+}
+
+void cPicturePlayer::SetPicture(const char *FileName)
+{
+  int f = open(FileName, O_RDONLY);
+  if (f >= 0) {
+     for (;;) {
+         length = read(f, buffer, size);
+         if (length > 0) {
+            if (length >= size) {
+               size = size * 3 / 2;
+               buffer = (uchar *)realloc(buffer, size);
+               lseek(f, 0, SEEK_SET);
+               continue;
+               }
+            DeviceStillPicture(buffer, length);
+            }
+         else
+            LOG_ERROR_STR(FileName);
+         break;
+         }
+     close(f);
+     }
+  else
+     LOG_ERROR_STR(FileName);
+}
+
+// --- cPictureControl -------------------------------------------------------
+
+int cPictureControl::active = 0;
+cString cPictureControl::lastDisplayed;
+
+cPictureControl::cPictureControl(cPictureEntry *Pictures, const cPictureEntry *PictureEntry, bool SlideShow)
+:cControl(player = new cPicturePlayer)
+{
+  pictures = Pictures;
+  pictureEntry = PictureEntry;
+  osd = NULL;
+  lastPath = "/";
+  slideShow = SlideShow;
+  alwaysDisplayCaption = false;
+  NextPicture(slideShow && pictureEntry->IsDirectory() ? 1 : 0);
+  active++;
+}
+
+cPictureControl::~cPictureControl()
+{
+  active--;
+  delete osd;
+  delete player;
+  delete pictures;
+}
+
+void cPictureControl::NextPicture(int Direction)
+{
+  if (Direction) {
+     const cPictureEntry *pe = Direction > 0 ? pictureEntry->NextPicture() : pictureEntry->PrevPicture();
+     if (pe)
+        pictureEntry = pe;
+     }
+  if (pictureEntry) {
+     player->SetPicture(pictureEntry->Path());
+     DisplayCaption();
+     }
+}
+
+void cPictureControl::NextDirectory(int Direction)
+{
+  // This only works reliable if a directory contains only subdirectories or pictures, not both!
+  if (Direction) {
+     const cPictureEntry *pe = Direction > 0 ? pictureEntry->Parent()->Entries()->Last()->NextPicture() : pictureEntry->Parent()->Entries()->First()->PrevPicture();
+     if (pe && Direction < 0)
+        pe = pe->Parent()->Entries()->First();
+     if (pe && pe != pictureEntry) {
+        pictureEntry = pe;
+        player->SetPicture(pictureEntry->Path());
+        DisplayCaption();
+        }
+     }
+}
+
+static void DrawTextOutlined(cOsd *Osd, int x, int y, const char *s, tColor ColorFg, tColor ColorBg, const cFont *Font)
+{
+  for (int dx = -1; dx <= 1; dx++) {
+      for (int dy = -1; dy <= 1; dy++) {
+          if (dx || dy)
+             Osd->DrawText(x + dx, y + dy, s, ColorBg, clrTransparent, Font);
+          }
+      }
+  Osd->DrawText(x, y, s, ColorFg, clrTransparent, Font);
+}
+
+void cPictureControl::DisplayCaption(void)
+{
+  bool Force = false;
+  cString Path = pictureEntry->Path();
+  lastDisplayed = Path + strlen(pictures->Name()) + 1;
+  const char *p = strrchr(Path, '/');
+  const char *q = strrchr(lastPath, '/');
+  if (p && q) {
+     int lp = p - Path;
+     int lq = q - lastPath;
+     if (lp != lq || strncmp(lastPath, Path, lp)) {
+        lastPath = Path;
+        Force = true;
+        }
+     }
+  if (!alwaysDisplayCaption && !Force) {
+     DELETENULL(osd);
+     return;
+     }
+  const cFont *Font = cFont::GetFont(fontOsd);
+  int w = cOsd::OsdWidth();
+  int h = 2 * Font->Height();
+  if (!osd) {
+     osd = cOsdProvider::NewOsd(cOsd::OsdLeft(), cOsd::OsdTop() + cOsd::OsdHeight() - h, OSD_LEVEL_SUBTITLES);
+     tArea Areas[] = { { 0, 0, w, h, 8 } };
+     if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+        osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     else {
+        tArea Areas[] = { { 0, 0, w, h, 4 } };
+        osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+        }
+     }
+  const char *Year = pictureEntry->Parent()->Parent() ? pictureEntry->Parent()->Parent()->Name() : "";
+  cString Description = HandleUnderscores(pictureEntry->Parent()->Name());
+  osd->DrawRectangle(0, 0, w - 1, h - 1, clrTransparent);
+  DrawTextOutlined(osd, 0, 0, Description, clrWhite, clrBlack, Font);
+  DrawTextOutlined(osd, 0, h / 2, Year, clrWhite, clrBlack, Font);
+  struct stat sb;
+  if (stat(Path, &sb) == 0) {
+     cString Time = DayDateTime(sb.st_mtime);
+     DrawTextOutlined(osd, w - Font->Width(Time), h / 2, Time, clrWhite, clrBlack, Font);
+     }
+  p++;
+  Path.Truncate(-4); // don't display the ".mpg" extension
+  DrawTextOutlined(osd, w - Font->Width(p), 0, p, clrWhite, clrBlack, Font);
+  osd->Flush();
+}
+
+eOSState cPictureControl::ProcessKey(eKeys Key)
+{
+  switch (Key) {
+    case kUp:
+    case kPlay:   slideShowDelay.Set();
+                  slideShow = true;
+                  break;
+    case kDown:
+    case kPause:  slideShow = false;
+                  break;
+    case kLeft|k_Repeat:
+    case kLeft:   NextPicture(-1);
+                  slideShow = false;
+                  break;
+    case kRight|k_Repeat:
+    case kRight:  NextPicture(+1);
+                  slideShow = false;
+                  break;
+    case kOk:     if (osd && !alwaysDisplayCaption)
+                     DELETENULL(osd);
+                  else {
+                     alwaysDisplayCaption = !alwaysDisplayCaption;
+                     DisplayCaption();
+                     }
+                  break;
+    case kGreen:
+    case kPrev:   NextDirectory(-1);
+                  slideShow = false;
+                  break;
+    case kYellow:
+    case kNext:   NextDirectory(+1);
+                  slideShow = false;
+                  break;
+    case kBlue:
+    case kStop:   return osEnd;
+    case kBack:   slideShow = false;
+                  cRemote::CallPlugin(PLUGIN_NAME_I18N);
+                  break;
+    default: break;
+    }
+  if (slideShow && slideShowDelay.TimedOut()) {
+     NextPicture(+1);
+     slideShowDelay.Set(SlideShowDelay * 1000);
+     }
+  return osContinue;
+}
+
+const char *cPictureControl::LastDisplayed(void)
+{
+  return lastDisplayed;
+}
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/player.h vdr-1.5.13/PLUGINS/src/pictures/player.h
--- vdr-1.5.12/PLUGINS/src/pictures/player.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/player.h	2008-01-12 17:21:57.000000000 +0100
@@ -0,0 +1,47 @@
+/*
+ * player.h: A player for still pictures
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: player.h 1.1 2008/01/12 16:21:57 kls Exp $
+ */
+
+#ifndef _PLAYER_H
+#define _PLAYER_H
+
+#include <vdr/osd.h>
+#include <vdr/player.h>
+#include <vdr/tools.h>
+#include "entry.h"
+
+extern int SlideShowDelay;
+
+cString HandleUnderscores(const char *s);
+
+class cPicturePlayer;
+
+class cPictureControl : public cControl {
+private:
+  static int active;
+  static cString lastDisplayed;
+  cPictureEntry *pictures;
+  const cPictureEntry *pictureEntry;
+  cPicturePlayer *player;
+  cOsd *osd;
+  cString lastPath;
+  cTimeMs slideShowDelay;
+  bool slideShow;
+  bool alwaysDisplayCaption;
+  void NextPicture(int Direction);
+  void NextDirectory(int Direction);
+  void DisplayCaption(void);
+  virtual void Hide(void) {}
+public:
+  cPictureControl(cPictureEntry *Pictures, const cPictureEntry *PictureEntry, bool SlideShow = false);
+  virtual ~cPictureControl();
+  virtual eOSState ProcessKey(eKeys Key);
+  static bool Active(void) { return active > 0; }
+  static const char *LastDisplayed(void);
+  };
+
+#endif //_PLAYER_H
diff -ruN vdr-1.5.12/PLUGINS/src/servicedemo/Makefile vdr-1.5.13/PLUGINS/src/servicedemo/Makefile
--- vdr-1.5.12/PLUGINS/src/servicedemo/Makefile	2007-08-15 15:05:42.000000000 +0200
+++ vdr-1.5.13/PLUGINS/src/servicedemo/Makefile	2008-01-13 14:00:07.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.9 2007/08/15 13:05:42 kls Exp $
+# $Id: Makefile 1.10 2008/01/13 13:00:07 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -18,7 +18,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual
+CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
diff -ruN vdr-1.5.12/PLUGINS/src/sky/Makefile vdr-1.5.13/PLUGINS/src/sky/Makefile
--- vdr-1.5.12/PLUGINS/src/sky/Makefile	2007-08-15 15:06:08.000000000 +0200
+++ vdr-1.5.13/PLUGINS/src/sky/Makefile	2008-01-13 14:00:16.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.10 2007/08/15 13:06:08 kls Exp $
+# $Id: Makefile 1.11 2008/01/13 13:00:16 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -16,7 +16,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual
+CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
diff -ruN vdr-1.5.12/PLUGINS/src/status/Makefile vdr-1.5.13/PLUGINS/src/status/Makefile
--- vdr-1.5.12/PLUGINS/src/status/Makefile	2007-08-15 15:06:17.000000000 +0200
+++ vdr-1.5.13/PLUGINS/src/status/Makefile	2008-01-13 14:00:18.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.14 2007/08/15 13:06:17 kls Exp $
+# $Id: Makefile 1.15 2008/01/13 13:00:18 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -16,7 +16,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual
+CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
diff -ruN vdr-1.5.12/PLUGINS/src/svdrpdemo/Makefile vdr-1.5.13/PLUGINS/src/svdrpdemo/Makefile
--- vdr-1.5.12/PLUGINS/src/svdrpdemo/Makefile	2007-08-15 15:06:28.000000000 +0200
+++ vdr-1.5.13/PLUGINS/src/svdrpdemo/Makefile	2008-01-13 14:00:20.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.8 2007/08/15 13:06:28 kls Exp $
+# $Id: Makefile 1.9 2008/01/13 13:00:20 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -16,7 +16,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual
+CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
diff -ruN vdr-1.5.12/config.c vdr-1.5.13/config.c
--- vdr-1.5.12/config.c	2007-10-06 16:28:58.000000000 +0200
+++ vdr-1.5.13/config.c	2007-11-25 14:46:27.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 1.157 2007/10/06 14:28:58 kls Exp $
+ * $Id: config.c 1.158 2007/11/25 13:46:27 kls Exp $
  */
 
 #include "config.h"
@@ -289,6 +289,7 @@
   CurrentDolby = 0;
   InitialChannel = 0;
   InitialVolume = -1;
+  EmergencyExit = 1;
 }
 
 cSetup& cSetup::operator= (const cSetup &s)
@@ -464,6 +465,7 @@
   else if (!strcasecmp(Name, "CurrentDolby"))        CurrentDolby       = atoi(Value);
   else if (!strcasecmp(Name, "InitialChannel"))      InitialChannel     = atoi(Value);
   else if (!strcasecmp(Name, "InitialVolume"))       InitialVolume      = atoi(Value);
+  else if (!strcasecmp(Name, "EmergencyExit"))       EmergencyExit      = atoi(Value);
   else
      return false;
   return true;
@@ -546,6 +548,7 @@
   Store("CurrentDolby",       CurrentDolby);
   Store("InitialChannel",     InitialChannel);
   Store("InitialVolume",      InitialVolume);
+  Store("EmergencyExit",      EmergencyExit);
 
   Sort();
 
diff -ruN vdr-1.5.12/config.h vdr-1.5.13/config.h
--- vdr-1.5.12/config.h	2007-11-10 14:38:19.000000000 +0100
+++ vdr-1.5.13/config.h	2007-11-25 14:45:48.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.301 2007/11/10 13:38:19 kls Exp $
+ * $Id: config.h 1.303 2007/11/25 13:45:48 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.5.12"
-#define VDRVERSNUM   10512  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.5.13"
+#define VDRVERSNUM   10513  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.5.12"
-#define APIVERSNUM   10512  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.5.13"
+#define APIVERSNUM   10513  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -266,6 +266,7 @@
   int CurrentDolby;
   int InitialChannel;
   int InitialVolume;
+  int EmergencyExit;
   int __EndData__;
   cSetup(void);
   cSetup& operator= (const cSetup &s);
diff -ruN vdr-1.5.12/cutter.c vdr-1.5.13/cutter.c
--- vdr-1.5.12/cutter.c	2007-08-25 12:33:18.000000000 +0200
+++ vdr-1.5.13/cutter.c	2008-01-13 13:22:21.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 1.17 2007/08/25 10:33:18 kls Exp $
+ * $Id: cutter.c 1.18 2008/01/13 12:22:21 kls Exp $
  */
 
 #include "cutter.h"
@@ -111,7 +111,9 @@
                  }
               }
            else {
-              error = "index";
+              // Error, unless we're past the last cut-in and there's no cut-out
+              if (Mark || LastMark)
+                 error = "index";
               break;
               }
 
diff -ruN vdr-1.5.12/dvbsubtitle.c vdr-1.5.13/dvbsubtitle.c
--- vdr-1.5.12/dvbsubtitle.c	2007-11-03 15:36:07.000000000 +0100
+++ vdr-1.5.13/dvbsubtitle.c	2007-11-25 14:33:08.000000000 +0100
@@ -7,7 +7,7 @@
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 1.2 2007/11/03 14:36:07 kls Exp $
+ * $Id: dvbsubtitle.c 1.3 2007/11/25 13:33:08 kls Exp $
  */
 
 #include "dvbsubtitle.h"
@@ -102,7 +102,7 @@
   uchar Get4Bits(const uchar *Data, int &Index);
   bool Decode2BppCodeString(const uchar *Data, int &Index, int&x, int y);
   bool Decode4BppCodeString(const uchar *Data, int &Index, int&x, int y);
-  bool Decode8BppCodeString(const uchar *Data, int &Index, int&y, int y);
+  bool Decode8BppCodeString(const uchar *Data, int &Index, int&x, int y);
 public:
   cSubtitleObject(int ObjectId, cBitmap *Bitmap);
   int ObjectId(void) { return objectId; }
diff -ruN vdr-1.5.12/menu.c vdr-1.5.13/menu.c
--- vdr-1.5.12/menu.c	2007-11-03 16:02:00.000000000 +0100
+++ vdr-1.5.13/menu.c	2008-01-13 14:59:33.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.465 2007/11/03 15:02:00 kls Exp $
+ * $Id: menu.c 1.469 2008/01/13 13:59:33 kls Exp $
  */
 
 #include "menu.h"
@@ -931,6 +931,7 @@
        case kRed:    state = OnOff(); break; // must go through SetHelpKeys()!
        case kGreen:  return New();
        case kYellow: state = Delete(); break;
+       case kInfo:
        case kBlue:   return Info();
                      break;
        default: break;
@@ -986,6 +987,7 @@
                   DisplayMenu()->Scroll(NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft, NORMALKEY(Key) == kLeft || NORMALKEY(Key) == kRight);
                   cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft);
                   return osContinue;
+    case kInfo:   return osBack;
     default: break;
     }
 
@@ -1057,12 +1059,13 @@
      char v = event->Vps() && (event->Vps() - event->StartTime()) ? 'V' : ' ';
      char r = event->SeenWithin(30) && event->IsRunning() ? '*' : ' ';
      const char *csn = channel ? channel->ShortName(true) : NULL;
+     cString eds = event->GetDateString();
      if (channel && withDate)
-        asprintf(&buffer, "%d\t%.*s\t%.*s\t%s\t%c%c%c\t%s", channel->Number(), Utf8SymChars(csn, 6), csn, 6, *event->GetDateString(), *event->GetTimeString(), t, v, r, event->Title());
+        asprintf(&buffer, "%d\t%.*s\t%.*s\t%s\t%c%c%c\t%s", channel->Number(), Utf8SymChars(csn, 6), csn, Utf8SymChars(eds, 6), *eds, *event->GetTimeString(), t, v, r, event->Title());
      else if (channel)
         asprintf(&buffer, "%d\t%.*s\t%s\t%c%c%c\t%s", channel->Number(), Utf8SymChars(csn, 6), csn, *event->GetTimeString(), t, v, r, event->Title());
      else
-        asprintf(&buffer, "%.*s\t%s\t%c%c%c\t%s", 6, *event->GetDateString(), *event->GetTimeString(), t, v, r, event->Title());
+        asprintf(&buffer, "%.*s\t%s\t%c%c%c\t%s", Utf8SymChars(eds, 6), *eds, *event->GetTimeString(), t, v, r, event->Title());
      SetText(buffer, false);
      result = true;
      }
@@ -1216,6 +1219,7 @@
                      }
                      break;
        case kBlue:   return Switch();
+       case kInfo:
        case kOk:     if (Count())
                         return AddSubMenu(new cMenuEvent(((cMenuScheduleItem *)Get(Current()))->event, true, true));
                      break;
@@ -1486,6 +1490,7 @@
        case kBlue:   if (Count() && otherChannel)
                         return Switch();
                      break;
+       case kInfo:
        case kOk:     if (Count())
                         return AddSubMenu(new cMenuEvent(((cMenuScheduleItem *)Get(Current()))->event, otherChannel, true));
                      break;
@@ -1815,6 +1820,7 @@
                   DisplayMenu()->Scroll(NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft, NORMALKEY(Key) == kLeft || NORMALKEY(Key) == kRight);
                   cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft);
                   return osContinue;
+    case kInfo:   return osBack;
     default: break;
     }
 
@@ -2112,6 +2118,7 @@
        case kRed:    return (helpKeys > 1 && RecordingCommands.Count()) ? Commands() : Play();
        case kGreen:  return Rewind();
        case kYellow: return Delete();
+       case kInfo:
        case kBlue:   return Info();
        case k1...k9: return Commands(Key);
        case kNone:   if (Recordings.StateChanged(recordingsState))
@@ -2760,6 +2767,7 @@
   Add(new cMenuEditIntItem( tr("Setup.Miscellaneous$Channel entry timeout (ms)"), &data.ChannelEntryTimeout, 0));
   Add(new cMenuEditChanItem(tr("Setup.Miscellaneous$Initial channel"),            &data.InitialChannel, tr("Setup.Miscellaneous$as before")));
   Add(new cMenuEditIntItem( tr("Setup.Miscellaneous$Initial volume"),             &data.InitialVolume, -1, 255, tr("Setup.Miscellaneous$as before")));
+  Add(new cMenuEditBoolItem(tr("Setup.Miscellaneous$Emergency exit"),             &data.EmergencyExit));
 }
 
 // --- cMenuSetupPluginItem --------------------------------------------------
@@ -3008,6 +3016,7 @@
         Minutes %= 60;
         //XXX -> skin function!!!
         SetTitle(cString::sprintf("%s  -  %s %d%%  -  %2d:%02d %s", tr("VDR"), tr("Disk"), Percent, Hours, Minutes, tr("free")));
+        lastFreeMB = FreeMB;
         result = true;
         }
      lastDiskSpaceCheck = time(NULL);
diff -ruN vdr-1.5.12/newplugin vdr-1.5.13/newplugin
--- vdr-1.5.12/newplugin	2007-11-04 11:42:52.000000000 +0100
+++ vdr-1.5.13/newplugin	2008-01-13 14:00:23.000000000 +0100
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 1.39 2007/11/04 10:42:52 kls Exp $
+# $Id: newplugin 1.41 2008/01/13 13:00:23 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -77,7 +77,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual
+CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
@@ -149,7 +149,7 @@
 	cp \$< \$\@
 
 .PHONY: i18n
-i18n: \$(I18Nmsgs)
+i18n: \$(I18Nmsgs) \$(I18Npot)
 
 ### Targets:
 
diff -ruN vdr-1.5.12/remux.c vdr-1.5.13/remux.c
--- vdr-1.5.12/remux.c	2007-11-18 15:45:28.000000000 +0100
+++ vdr-1.5.13/remux.c	2007-11-25 14:56:03.000000000 +0100
@@ -11,7 +11,7 @@
  * The cRepacker family's code was originally written by Reinhard Nissl <rnissl@gmx.de>,
  * and adapted to the VDR coding style by Klaus.Schmidinger@cadsoft.de.
  *
- * $Id: remux.c 1.63 2007/11/18 14:45:28 kls Exp $
+ * $Id: remux.c 1.64 2007/11/25 13:56:03 kls Exp $
  */
 
 #include "remux.h"
@@ -2099,8 +2099,10 @@
                if (pt != NO_PICTURE) {
                   if (pt < I_FRAME || B_FRAME < pt) {
                      esyslog("ERROR: unknown picture type '%d'", pt);
-                     if (++numUPTerrors > MAXNUMUPTERRORS && exitOnFailure)
+                     if (++numUPTerrors > MAXNUMUPTERRORS && exitOnFailure) {
                         ShutdownHandler.RequestEmergencyExit();
+                        numUPTerrors = 0;
+                        }
                      }
                   else if (!synced) {
                      if (pt == I_FRAME) {
diff -ruN vdr-1.5.12/shutdown.c vdr-1.5.13/shutdown.c
--- vdr-1.5.12/shutdown.c	2007-10-19 16:33:40.000000000 +0200
+++ vdr-1.5.13/shutdown.c	2008-01-13 15:27:29.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * Original version written by Udo Richter <udo_richter@gmx.de>.
  *
- * $Id: shutdown.c 1.2 2007/10/19 14:33:40 kls Exp $
+ * $Id: shutdown.c 1.4 2008/01/13 14:27:29 kls Exp $
  */
 
 #include "shutdown.h"
@@ -95,9 +95,13 @@
 
 void cShutdownHandler::RequestEmergencyExit(void)
 {
-  esyslog("initiating emergency exit");
-  emergencyExitRequested = true;
-  Exit(1);
+  if (Setup.EmergencyExit) {
+     esyslog("initiating emergency exit");
+     emergencyExitRequested = true;
+     Exit(1);
+     }
+  else
+     dsyslog("emergency exit request ignored according to setup");
 }
 
 void cShutdownHandler::CheckManualStart(int ManualStart)
@@ -150,6 +154,9 @@
 
 bool cShutdownHandler::ConfirmShutdown(bool Interactive)
 {
+  if (!Interactive && !cRemote::Enabled())
+     return false;
+
   if (!shutdownCommand) {
      if (Interactive)
         Skins.Message(mtError, tr("Can't shutdown - option '-s' not given!"));
diff -ruN vdr-1.5.12/skinclassic.c vdr-1.5.13/skinclassic.c
--- vdr-1.5.12/skinclassic.c	2007-07-29 14:35:03.000000000 +0200
+++ vdr-1.5.13/skinclassic.c	2008-01-13 13:38:00.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 1.18 2007/07/29 12:35:03 kls Exp $
+ * $Id: skinclassic.c 1.19 2008/01/13 12:38:00 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -162,6 +162,7 @@
   int x0, x1;
   int y0, y1, y2, y3, y4, y5;
   int lineHeight;
+  int dateWidth;
   cString lastDate;
   void SetScrollbar(void);
 public:
@@ -186,6 +187,7 @@
 {
   const cFont *font = cFont::GetFont(fontOsd);
   lineHeight = font->Height();
+  dateWidth = 0;
   x0 = 0;
   x1 = cOsd::OsdWidth();
   y0 = 0;
@@ -253,7 +255,7 @@
 void cSkinClassicDisplayMenu::SetTitle(const char *Title)
 {
   const cFont *font = cFont::GetFont(fontOsd);
-  osd->DrawText(x0, y0, Title, Theme.Color(clrMenuTitleFg), Theme.Color(clrMenuTitleBg), font, x1 - x0);
+  osd->DrawText(x0, y0, Title, Theme.Color(clrMenuTitleFg), Theme.Color(clrMenuTitleBg), font, x1 - x0 - dateWidth);
 }
 
 void cSkinClassicDisplayMenu::SetButtons(const char *Red, const char *Green, const char *Yellow, const char *Blue)
@@ -395,6 +397,7 @@
      int w = font->Width(date);
      osd->DrawText(x1 - w - 2, y0, date, Theme.Color(clrMenuDate), Theme.Color(clrMenuTitleBg), font, w);
      lastDate = date;
+     dateWidth = max(w + 2, dateWidth);
      }
   osd->Flush();
 }
diff -ruN vdr-1.5.12/svdrp.c vdr-1.5.13/svdrp.c
--- vdr-1.5.12/svdrp.c	2007-10-13 12:17:48.000000000 +0200
+++ vdr-1.5.13/svdrp.c	2008-01-13 16:06:25.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 1.104 2007/10/13 10:17:48 kls Exp $
+ * $Id: svdrp.c 1.105 2008/01/13 15:06:25 kls Exp $
  */
 
 #include "svdrp.h"
@@ -185,8 +185,9 @@
   "    Switch channel up, down or to the given channel number, name or id.\n"
   "    Without option (or after successfully switching to the channel)\n"
   "    it returns the current channel number and name.",
-  "CLRE\n"
-  "    Clear the entire EPG list.",
+  "CLRE [ <number> | <name> | <id> ]\n"
+  "    Clear the EPG list of the given channel number, name or id.\n"
+  "    Without option it clears the entire EPG list.",
   "DELC <number>\n"
   "    Delete channel.",
   "DELR <number>\n"
@@ -538,8 +539,57 @@
 
 void cSVDRP::CmdCLRE(const char *Option)
 {
-  cSchedules::ClearAll();
-  Reply(250, "EPG data cleared");
+  if (*Option) {
+     tChannelID ChannelID = tChannelID::InvalidID;
+     if (isnumber(Option)) {
+        int o = strtol(Option, NULL, 10);
+        if (o >= 1 && o <= Channels.MaxNumber())
+           ChannelID = Channels.GetByNumber(o)->GetChannelID();
+        }
+     else {
+        ChannelID = tChannelID::FromString(Option);
+        if (ChannelID == tChannelID::InvalidID) {
+           for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
+               if (!Channel->GroupSep()) {
+                  if (strcasecmp(Channel->Name(), Option) == 0) {
+                     ChannelID = Channel->GetChannelID();
+                     break;
+                     }
+                  }
+               }
+           }
+        }
+     if (!(ChannelID == tChannelID::InvalidID)) {
+        cSchedulesLock SchedulesLock(true, 1000);
+        cSchedules *s = (cSchedules *)cSchedules::Schedules(SchedulesLock);
+        if (s) {
+           cSchedule *Schedule = NULL;
+           ChannelID.ClrRid();
+           for (cSchedule *p = s->First(); p; p = s->Next(p)) {
+               if (p->ChannelID() == ChannelID) {
+                  Schedule = p;
+                  break;
+                  }
+               }
+           if (Schedule) {
+              Schedule->Cleanup(INT_MAX);
+              Reply(250, "EPG data of channel \"%s\" cleared", Option);
+              }
+           else {
+              Reply(550, "No EPG data found for channel \"%s\"", Option);
+              return;
+              }
+           }
+        else
+           Reply(451, "Can't get EPG data");
+        }
+     else
+        Reply(501, "Undefined channel \"%s\"", Option);
+     }
+  else {
+     cSchedules::ClearAll();
+     Reply(250, "EPG data cleared");
+     }
 }
 
 void cSVDRP::CmdDELC(const char *Option)
diff -ruN vdr-1.5.12/tools.c vdr-1.5.13/tools.c
--- vdr-1.5.12/tools.c	2007-11-03 16:34:07.000000000 +0100
+++ vdr-1.5.13/tools.c	2008-01-13 12:26:30.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.137 2007/11/03 15:34:07 kls Exp $
+ * $Id: tools.c 1.140 2008/01/13 11:26:30 kls Exp $
  */
 
 #include "tools.h"
@@ -545,6 +545,41 @@
 
 uint64_t cTimeMs::Now(void)
 {
+#if _POSIX_TIMERS > 0 && defined(_POSIX_MONOTONIC_CLOCK)
+#define MIN_RESOLUTION 5 // ms
+  static bool initialized = false;
+  static bool monotonic = false;
+  struct timespec tp;
+  if (!initialized) {
+     // check if monotonic timer is available and provides enough accurate resolution:
+     if (clock_getres(CLOCK_MONOTONIC, &tp) == 0) {
+        long Resolution = tp.tv_nsec;
+        // require a minimum resolution:
+        if (tp.tv_sec == 0 && tp.tv_nsec <= MIN_RESOLUTION * 1000000) {
+           if (clock_gettime(CLOCK_MONOTONIC, &tp) == 0) {
+              dsyslog("cTimeMs: using monotonic clock (resolution is %ld ns)", Resolution);
+              monotonic = true;
+              }
+           else
+              esyslog("cTimeMs: clock_gettime(CLOCK_MONOTONIC) failed");
+           }
+        else
+           dsyslog("cTimeMs: not using monotonic clock - resolution is too bad (%ld s %ld ns)", tp.tv_sec, tp.tv_nsec);
+        }
+     else
+        esyslog("cTimeMs: clock_getres(CLOCK_MONOTONIC) failed");
+     initialized = true;
+     }
+  if (monotonic) {
+     if (clock_gettime(CLOCK_MONOTONIC, &tp) == 0)
+        return (uint64_t(tp.tv_sec)) * 1000 + tp.tv_nsec / 1000000;
+     esyslog("cTimeMs: clock_gettime(CLOCK_MONOTONIC) failed");
+     monotonic = false;
+     // fall back to gettimeofday()
+     }
+#else
+#  warning Posix monotonic clock not available
+#endif
   struct timeval t;
   if (gettimeofday(&t, NULL) == 0)
      return (uint64_t(t.tv_sec)) * 1000 + t.tv_usec / 1000;
@@ -838,6 +873,16 @@
   return *this;
 }
 
+cString &cString::Truncate(int Index)
+{
+  int l = strlen(s);
+  if (Index < 0)
+     Index = l + Index;
+  if (Index >= 0 && Index < l)
+     s[Index] = 0;
+  return *this;
+}
+
 cString cString::sprintf(const char *fmt, ...)
 {
   va_list ap;
@@ -1174,6 +1219,7 @@
 {
   for (int i = 0; i < Size(); i++)
       free(At(i));
+  cVector<char *>::Clear();
 }
 
 // --- cFileNameList ---------------------------------------------------------
diff -ruN vdr-1.5.12/tools.h vdr-1.5.13/tools.h
--- vdr-1.5.12/tools.h	2007-08-25 16:16:39.000000000 +0200
+++ vdr-1.5.13/tools.h	2008-01-13 12:22:26.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.108 2007/08/25 14:16:39 kls Exp $
+ * $Id: tools.h 1.110 2008/01/13 11:22:26 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -159,6 +159,7 @@
   operator const char * () const { return s; } // for use in (const char *) context
   const char * operator*() const { return s; } // for use in (const void *) context (printf() etc.)
   cString &operator=(const cString &String);
+  cString &Truncate(int Index); ///< Truncate the string at the given Index (if Index is < 0 it is counted from the end of the string).
   static cString sprintf(const char *fmt, ...) __attribute__ ((format (printf, 1, 2)));
   };
 
@@ -470,7 +471,10 @@
        memmove(&data[Index], &data[Index + 1], (size - Index) * sizeof(T));
     size--;
   }
-  virtual void Clear(void) {}
+  virtual void Clear(void)
+  {
+    size = 0;
+  }
   void Sort(__compar_fn_t Compare)
   {
     qsort(data, size, sizeof(T), Compare);
